#!/bin/bash

#  此脚本为varnish一键编译安装调优的入口脚本，需要配置参数后（稍后由参数说明），直接命令行运行sh install.sh即可实现varnish一键编译安装部署调优

##################需要配置的参数#####################
eth0=""                           #当前环境的通讯网口名，不能使用GE网卡，必填项
IP=""                   #通讯网口eth0的IP，必填项
#####################################################

#日志
log=varnish_install.log
rm -rf $log

#编译部署
function CompileAndDeploy(){
	#编译脚本执行
	cd ./deps/
	if [ ! -f varnish-6.2.0-1.el7.aarch64.rpm ];then
        	sh varnish_build.sh
		if [ $? -ne 0 ];then
			echo "varnish build failed!"
			exit 1
		fi
	fi
	#安装脚本执行
        rpm -qa |grep varnish-6.2.0
        if [ $? -ne 0 ];then
                sh varnish_install.sh
                if [ $? -ne 0 ];then
                        echo "varnish install failed !"
                        exit 1
                fi
        fi
        cd ..
}


function VarnishOptimization(){
        #将中断绑核脚本cp到varnish目录
        if [ ! -f /usr/local/varnish/config/default.vcl.bak ];then
               cp /usr/local/varnish/config/default.vcl /usr/local/varnish/config/default.vcl.bak
        fi
        cp /usr/local/varnish/config/default.vcl.bak /usr/local/varnish/config/default.vcl
        cp ./scripts/irq_default.sh /usr/local/varnish/
        cp ./scripts/varnish_optimization.sh /usr/local/varnish/
        systemctl start irqbalance.service
        systemctl disable irqbalance.service
        sh /usr/local/varnish/irq_default.sh $eth0 
        sh /usr/local/varnish/varnish_optimization.sh $IP
}

#-----------------------------------shell beging------------------------------------
if [[ -z $eth0 ]];then
        echo "please config The NIC name in the install.sh"
        exit 1
fi

if [[ -z $IP ]];then
        echo "please config The IP in the install.sh"
        exit 1
fi

#编译安装
echo "################################## begine to build and install  ##################################" | tee -a $log
CompileAndDeploy | tee -a $log
#调优
echo "################################## begine to optimize  ##################################" | tee -a $log
sh ./scripts/gerneral_optimization.sh | tee -a $log
VarnishOptimization | tee -a $log




















































echo "you need to reboot to make the optimization work" | tee -a $log
