#!/bin/bash

isDocker=false
#扩展文件描述符
function LimitsSet(){
	echo "*	soft	nofile	102400" >> /etc/security/limits.conf
	echo "*	hard	nofile	102400" >> /etc/security/limits.conf
}
#配置内核参数
function SysctlSet(){
        if [ ! -f /etc/sysctl.conf_bak ];then
               cp /etc/sysctl.conf /etc/sysctl.conf_bak
        fi
	\cp /etc/sysctl.conf_bak /etc/sysctl.conf
	echo "net.ipv4.tcp_tw_reuse = 1" >> /etc/sysctl.conf
	echo "net.ipv4.tcp_keepalive_time = 60" >> /etc/sysctl.conf
	echo "net.ipv4.tcp_fin_timeout = 1" >> /etc/sysctl.conf
	echo "net.ipv4.tcp_max_tw_buckets = 5000" >> /etc/sysctl.conf
	echo "net.ipv4.ip_local_port_range = 1024     65500" >> /etc/sysctl.conf
	echo "net.core.somaxconn = 65535" >> /etc/sysctl.conf
	echo "net.ipv4.tcp_max_syn_backlog = 262144" >> /etc/sysctl.conf
	echo "net.core.netdev_max_backlog = 262144" >> /etc/sysctl.conf
	echo "net.core.rmem_max = 16777216" >> /etc/sysctl.conf
	echo "net.core.wmem_max = 16777216" >> /etc/sysctl.conf
	if $isDocker;then
		echo "net.netfilter.nf_conntrack_max = 0" >> /etc/sysctl.conf
		echo "net.nf_conntrack_max = 0" >> /etc/sysctl.conf
	fi
	/sbin/sysctl -p
}
#关闭nf_conntrack模块
function CloseNfconntrack(){
	if $isDocker;then
		exit 1;
	fi

	touch /etc/modprobe.d/blacklist.conf
	echo "install nf_conntrack /bin/false" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist nf_conntrack" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist nf_conntrack_ipv6" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist xt_conntrack" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist nf_conntrack_ftp" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist xt_state" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist iptable_nat" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist ipt_REDIRECT" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist nf_nat" >> /etc/modprobe.d/blacklist.conf
	echo "blacklist nf_conntrack_ipv4" >> /etc/modprobe.d/blacklist.conf

}
#关闭selinux
function CloseSelinux(){
	sed -i 's/SELINUX=enforcing/SELINUX=disabled/g' /etc/sysconfig/selinux
}
#设置iommu
function IommuSet(){
	sed -i '/centos-root/ s/$/ iommu.passthrough=1/' /etc/grub2-efi.cfg
}

LimitsSet
SysctlSet
CloseNfconntrack
CloseSelinux
IommuSet
