#!/bin/bash
varnishIP=$1
varnishPort=80
VarnishFile=/usr/local/varnish/config/default.vcl

#function AddVclConfig{
     #add vcl_default config
     sed -i "/vcl 4.0/a\import directors;" $VarnishFile
     sed -i "s/127.0.0.1/$varnishIP/g" $VarnishFile
     sed -i "s/8080/$varnishPort/g" $VarnishFile
     #add vcl_recv config
     sed -i "/vcl_recv {/a\if (req.http.x-forwarded-for) {\n \
          set req.http.X-Forwarded-For = req.http.X-Forwarded-For + \", \" + client.ip;\n \
          } else {\n  \
          set req.http.X-Forwarded-For = client.ip;\n \
          }\n \
          if (req.method != \"GET\" &&\n \
          req.method != \"HEAD\" &&\n \
          req.method != \"PUT\" &&\n \
          req.method != \"POST\" &&\n \
          req.method != \"TRACE\" &&\n \
          req.method != \"OPTIONS\" &&\n \
          req.method != \"DELETE\") {\n \
          /* Non-RFC2616 or CONNECT which is weird. */\n \
          return (pipe);\n \
          }\n \
          if (req.method != \"GET\" && req.method != \"HEAD\") {\n \
          return (pass);\n \
          }\n \
          if (req.http.Authorization || req.http.Cookie) {\n \
          return (pass);\n \
          }"   $VarnishFile
     
     #add vcl_backend_response config
     sed -i "/vcl_backend_response {/a set beresp.ttl = 120m;"   $VarnishFile
     
     #add vcl_deliver config
     sed -i "/vcl_deliver {/a\set req.http.Connection = \"keep-alive\";\n \
         if (obj.hits > 0){\n \
         set resp.http.X-Cache = \"HIT from\" + server.ip;\n \
         } else{\n \
         set resp.http.X-Cache = \"MISS\";\n \
         }"  $VarnishFile
     
         
     #add vcl_pipe config
     sed -i "/vcl_deliver/i\sub vcl_pipe {\n \
         return (pipe);\n \
         }\n" /usr/local/varnish/config/default.vcl
     
     sed -i "/vcl_deliver/i\sub vcl_pass {\n \
         if (req.method == \"PURGE\"){\n \
         return(synth(502,\"PURGE on a passed object\"));\n \
         }\n \
         }\n" /usr/local/varnish/config/default.vcl
     
     
     #add vcl_hash config
     sed -i "/vcl_deliver/i\sub vcl_hash {\n \
         hash_data(req.url);\n \
         if (req.http.host) {\n \
         hash_data(req.http.host);\n \
         } else {\n  \
         hash_data(server.ip);\n \
         }\n \
         return (lookup);\n \
         }\n" /usr/local/varnish/config/default.vcl
     
     #add vcl_hit config
     sed -i "/vcl_deliver/i\sub vcl_hit {\n \
         return (deliver);\n \
         }\n" /usr/local/varnish/config/default.vcl
     
     #add vcl_miss config
     sed -i "/vcl_deliver/i\sub vcl_miss {\n \
         return (fetch);\n \
         }\n" /usr/local/varnish/config/default.vcl
     
#}
# AddVclConfig
